// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion6

// SphynxClient is the client API for Sphynx service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SphynxClient interface {
	CanCompute(ctx context.Context, in *CanComputeRequest, opts ...grpc.CallOption) (*CanComputeReply, error)
	Compute(ctx context.Context, in *ComputeRequest, opts ...grpc.CallOption) (*ComputeReply, error)
	GetScalar(ctx context.Context, in *GetScalarRequest, opts ...grpc.CallOption) (*GetScalarReply, error)
	WriteToUnorderedDisk(ctx context.Context, in *WriteToUnorderedDiskRequest, opts ...grpc.CallOption) (*WriteToUnorderedDiskReply, error)
	ReadFromUnorderedDisk(ctx context.Context, in *ReadFromUnorderedDiskRequest, opts ...grpc.CallOption) (*ReadFromUnorderedDiskReply, error)
	WriteToOrderedDisk(ctx context.Context, in *WriteToOrderedDiskRequest, opts ...grpc.CallOption) (*WriteToOrderedDiskReply, error)
	ReadFromOrderedSphynxDisk(ctx context.Context, in *ReadFromOrderedSphynxDiskRequest, opts ...grpc.CallOption) (*ReadFromOrderedSphynxDiskReply, error)
	HasOnOrderedSphynxDisk(ctx context.Context, in *HasOnOrderedSphynxDiskRequest, opts ...grpc.CallOption) (*HasOnOrderedSphynxDiskReply, error)
	HasInSphynxMemory(ctx context.Context, in *HasInSphynxMemoryRequest, opts ...grpc.CallOption) (*HasInSphynxMemoryReply, error)
	Clear(ctx context.Context, in *ClearRequest, opts ...grpc.CallOption) (*ClearReply, error)
}

type sphynxClient struct {
	cc grpc.ClientConnInterface
}

func NewSphynxClient(cc grpc.ClientConnInterface) SphynxClient {
	return &sphynxClient{cc}
}

func (c *sphynxClient) CanCompute(ctx context.Context, in *CanComputeRequest, opts ...grpc.CallOption) (*CanComputeReply, error) {
	out := new(CanComputeReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/CanCompute", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) Compute(ctx context.Context, in *ComputeRequest, opts ...grpc.CallOption) (*ComputeReply, error) {
	out := new(ComputeReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/Compute", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) GetScalar(ctx context.Context, in *GetScalarRequest, opts ...grpc.CallOption) (*GetScalarReply, error) {
	out := new(GetScalarReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/GetScalar", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) WriteToUnorderedDisk(ctx context.Context, in *WriteToUnorderedDiskRequest, opts ...grpc.CallOption) (*WriteToUnorderedDiskReply, error) {
	out := new(WriteToUnorderedDiskReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/WriteToUnorderedDisk", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) ReadFromUnorderedDisk(ctx context.Context, in *ReadFromUnorderedDiskRequest, opts ...grpc.CallOption) (*ReadFromUnorderedDiskReply, error) {
	out := new(ReadFromUnorderedDiskReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/ReadFromUnorderedDisk", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) WriteToOrderedDisk(ctx context.Context, in *WriteToOrderedDiskRequest, opts ...grpc.CallOption) (*WriteToOrderedDiskReply, error) {
	out := new(WriteToOrderedDiskReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/WriteToOrderedDisk", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) ReadFromOrderedSphynxDisk(ctx context.Context, in *ReadFromOrderedSphynxDiskRequest, opts ...grpc.CallOption) (*ReadFromOrderedSphynxDiskReply, error) {
	out := new(ReadFromOrderedSphynxDiskReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/ReadFromOrderedSphynxDisk", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) HasOnOrderedSphynxDisk(ctx context.Context, in *HasOnOrderedSphynxDiskRequest, opts ...grpc.CallOption) (*HasOnOrderedSphynxDiskReply, error) {
	out := new(HasOnOrderedSphynxDiskReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/HasOnOrderedSphynxDisk", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) HasInSphynxMemory(ctx context.Context, in *HasInSphynxMemoryRequest, opts ...grpc.CallOption) (*HasInSphynxMemoryReply, error) {
	out := new(HasInSphynxMemoryReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/HasInSphynxMemory", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sphynxClient) Clear(ctx context.Context, in *ClearRequest, opts ...grpc.CallOption) (*ClearReply, error) {
	out := new(ClearReply)
	err := c.cc.Invoke(ctx, "/sphynx.Sphynx/Clear", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SphynxServer is the server API for Sphynx service.
// All implementations must embed UnimplementedSphynxServer
// for forward compatibility
type SphynxServer interface {
	CanCompute(context.Context, *CanComputeRequest) (*CanComputeReply, error)
	Compute(context.Context, *ComputeRequest) (*ComputeReply, error)
	GetScalar(context.Context, *GetScalarRequest) (*GetScalarReply, error)
	WriteToUnorderedDisk(context.Context, *WriteToUnorderedDiskRequest) (*WriteToUnorderedDiskReply, error)
	ReadFromUnorderedDisk(context.Context, *ReadFromUnorderedDiskRequest) (*ReadFromUnorderedDiskReply, error)
	WriteToOrderedDisk(context.Context, *WriteToOrderedDiskRequest) (*WriteToOrderedDiskReply, error)
	ReadFromOrderedSphynxDisk(context.Context, *ReadFromOrderedSphynxDiskRequest) (*ReadFromOrderedSphynxDiskReply, error)
	HasOnOrderedSphynxDisk(context.Context, *HasOnOrderedSphynxDiskRequest) (*HasOnOrderedSphynxDiskReply, error)
	HasInSphynxMemory(context.Context, *HasInSphynxMemoryRequest) (*HasInSphynxMemoryReply, error)
	Clear(context.Context, *ClearRequest) (*ClearReply, error)
	mustEmbedUnimplementedSphynxServer()
}

// UnimplementedSphynxServer must be embedded to have forward compatible implementations.
type UnimplementedSphynxServer struct {
}

func (*UnimplementedSphynxServer) CanCompute(context.Context, *CanComputeRequest) (*CanComputeReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CanCompute not implemented")
}
func (*UnimplementedSphynxServer) Compute(context.Context, *ComputeRequest) (*ComputeReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Compute not implemented")
}
func (*UnimplementedSphynxServer) GetScalar(context.Context, *GetScalarRequest) (*GetScalarReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetScalar not implemented")
}
func (*UnimplementedSphynxServer) WriteToUnorderedDisk(context.Context, *WriteToUnorderedDiskRequest) (*WriteToUnorderedDiskReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method WriteToUnorderedDisk not implemented")
}
func (*UnimplementedSphynxServer) ReadFromUnorderedDisk(context.Context, *ReadFromUnorderedDiskRequest) (*ReadFromUnorderedDiskReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReadFromUnorderedDisk not implemented")
}
func (*UnimplementedSphynxServer) WriteToOrderedDisk(context.Context, *WriteToOrderedDiskRequest) (*WriteToOrderedDiskReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method WriteToOrderedDisk not implemented")
}
func (*UnimplementedSphynxServer) ReadFromOrderedSphynxDisk(context.Context, *ReadFromOrderedSphynxDiskRequest) (*ReadFromOrderedSphynxDiskReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReadFromOrderedSphynxDisk not implemented")
}
func (*UnimplementedSphynxServer) HasOnOrderedSphynxDisk(context.Context, *HasOnOrderedSphynxDiskRequest) (*HasOnOrderedSphynxDiskReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method HasOnOrderedSphynxDisk not implemented")
}
func (*UnimplementedSphynxServer) HasInSphynxMemory(context.Context, *HasInSphynxMemoryRequest) (*HasInSphynxMemoryReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method HasInSphynxMemory not implemented")
}
func (*UnimplementedSphynxServer) Clear(context.Context, *ClearRequest) (*ClearReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Clear not implemented")
}
func (*UnimplementedSphynxServer) mustEmbedUnimplementedSphynxServer() {}

func RegisterSphynxServer(s *grpc.Server, srv SphynxServer) {
	s.RegisterService(&_Sphynx_serviceDesc, srv)
}

func _Sphynx_CanCompute_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CanComputeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).CanCompute(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/CanCompute",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).CanCompute(ctx, req.(*CanComputeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_Compute_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ComputeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).Compute(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/Compute",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).Compute(ctx, req.(*ComputeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_GetScalar_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetScalarRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).GetScalar(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/GetScalar",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).GetScalar(ctx, req.(*GetScalarRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_WriteToUnorderedDisk_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(WriteToUnorderedDiskRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).WriteToUnorderedDisk(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/WriteToUnorderedDisk",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).WriteToUnorderedDisk(ctx, req.(*WriteToUnorderedDiskRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_ReadFromUnorderedDisk_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReadFromUnorderedDiskRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).ReadFromUnorderedDisk(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/ReadFromUnorderedDisk",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).ReadFromUnorderedDisk(ctx, req.(*ReadFromUnorderedDiskRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_WriteToOrderedDisk_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(WriteToOrderedDiskRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).WriteToOrderedDisk(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/WriteToOrderedDisk",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).WriteToOrderedDisk(ctx, req.(*WriteToOrderedDiskRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_ReadFromOrderedSphynxDisk_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReadFromOrderedSphynxDiskRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).ReadFromOrderedSphynxDisk(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/ReadFromOrderedSphynxDisk",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).ReadFromOrderedSphynxDisk(ctx, req.(*ReadFromOrderedSphynxDiskRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_HasOnOrderedSphynxDisk_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(HasOnOrderedSphynxDiskRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).HasOnOrderedSphynxDisk(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/HasOnOrderedSphynxDisk",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).HasOnOrderedSphynxDisk(ctx, req.(*HasOnOrderedSphynxDiskRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_HasInSphynxMemory_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(HasInSphynxMemoryRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).HasInSphynxMemory(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/HasInSphynxMemory",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).HasInSphynxMemory(ctx, req.(*HasInSphynxMemoryRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Sphynx_Clear_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ClearRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SphynxServer).Clear(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/sphynx.Sphynx/Clear",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SphynxServer).Clear(ctx, req.(*ClearRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _Sphynx_serviceDesc = grpc.ServiceDesc{
	ServiceName: "sphynx.Sphynx",
	HandlerType: (*SphynxServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CanCompute",
			Handler:    _Sphynx_CanCompute_Handler,
		},
		{
			MethodName: "Compute",
			Handler:    _Sphynx_Compute_Handler,
		},
		{
			MethodName: "GetScalar",
			Handler:    _Sphynx_GetScalar_Handler,
		},
		{
			MethodName: "WriteToUnorderedDisk",
			Handler:    _Sphynx_WriteToUnorderedDisk_Handler,
		},
		{
			MethodName: "ReadFromUnorderedDisk",
			Handler:    _Sphynx_ReadFromUnorderedDisk_Handler,
		},
		{
			MethodName: "WriteToOrderedDisk",
			Handler:    _Sphynx_WriteToOrderedDisk_Handler,
		},
		{
			MethodName: "ReadFromOrderedSphynxDisk",
			Handler:    _Sphynx_ReadFromOrderedSphynxDisk_Handler,
		},
		{
			MethodName: "HasOnOrderedSphynxDisk",
			Handler:    _Sphynx_HasOnOrderedSphynxDisk_Handler,
		},
		{
			MethodName: "HasInSphynxMemory",
			Handler:    _Sphynx_HasInSphynxMemory_Handler,
		},
		{
			MethodName: "Clear",
			Handler:    _Sphynx_Clear_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/sphynx.proto",
}
